//   Copyright (c)  1997-2006  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License (version 2)
//   as published by the Free Software Foundation.  A copy of the full
//   licence may be found in the file COPYING in this directory.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoA; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef DUPZFACTOR_BOUND_H
#define DUPZFACTOR_BOUND_H

#include "DUPZ.h"

struct DUPZfactor_bound_struct
{
  int df;
  double leading_coeff;
  double trailing_coeff;
  int dmax;
  double Bombieri2;
  double Mahler;
  double root_bound;
  double reverse_root_bound;
  double all_factors; /* a bound for all factors except perhaps one */
  double lift_bound;
};

typedef struct DUPZfactor_bound_struct *bound_info;

bound_info DUPZfactor_bound_ctor(const DUPZ f, int dmax);
void DUPZfactor_bound_dtor(bound_info bd);
void DUPZrefine_bound(bound_info bd, const DUPZ f, int dmax);
bound_info DUPZcopy_refine_bound(bound_info bd, const DUPZ f, int dmax);


#endif
